
/**
 * Klasse Vigenere.
 * 
 * @author claus albowski
 * @version okt'07
 */
public class Vigenere
{
    private String original, chiffrat, dechiffrat, schluessel;

    /**
     * Konstruktor fr Objekte der Klasse Vigenere
     */
    public Vigenere()   {
        original = "ORIGINAL";
        chiffrat = "CHIFFRAT";
        dechiffrat = "DECHIFFRAT";
        schluessel = "ABCDE";
    }
    
    /**
     * setzt den Schlssel.
     */
    public void setzeSchluessel(String string){
        schluessel = string;
    }
    
    /**
     * setzt den Originaltext.
     */
    public void setzeOriginal(String text){
        original=text.toUpperCase();
    }
    
    /**
     * setzt den Chiffrattext.
     */
    public void setzeChiffrat(String text){
        chiffrat=text.toUpperCase();
    }
    
    /**
     * zeigt das Chiffrat an.
     */
    public String gibChiffrat(){
        return chiffrat;
    }

    /**
     * zeigt das Dechiffrat an.
     */
    public String gibDechiffrat(){
        return dechiffrat;
    }
    
    // bersetzungsmethoden:
    
    /**
     * chiffriert ein einzelnes Zeichen
     * mit dem definierten Schlsselbuchstaben.
     */
    private char chiffriereEinZeichen(char zeichen, char schluesselbuchstabe) {
        int zahl = (int) zeichen;
        int key  = (int) schluesselbuchstabe;
        int ergebnis = ((zahl-65 + key-65) % 26) + 65;
        return (char) ergebnis;
    }
    
    /**
     * dechiffriert ein einzelnes Zeichen
     * mit dem definierten Schlsselbuchstaben.
     */
    private char dechiffriereEinZeichen(char zeichen, char schluesselbuchstabe) {
        int zahl = (int) zeichen;
        int key  = (int) schluesselbuchstabe;
        int ergebnis = ((zahl-65 - (key-65) + 26) % 26) + 65;
        return (char) ergebnis;
    }
    
    /**
     * chiffriert den Original-Text
     * mit dem definierten Schlssel.
     */
    public void chiffriere() {
        StringBuffer temp = new StringBuffer();
        int j = 0; //Zhler fr den index im Schlssel
        for (int i=0; i<original.length();i++){
            // Absicherung auf Grobuchstaben: 
            if (original.charAt(i)>64) if (original.charAt(i)<91)
            temp.append(chiffriereEinZeichen(original.charAt(i),schluessel.charAt(j)));
            j = (j+1) % schluessel.length();
        }
        chiffrat=temp.toString();
    }
       
    /**
     * dechiffriert den Chiffrat-Text
     * mit dem definierten Schlsselbuchstaben.
     */
    public void dechiffriere() {
        StringBuffer temp = new StringBuffer();
        int j = 0; //Zhler fr den index im Schlssel
        for (int i=0; i<chiffrat.length();i++){
            // Absicherung auf Grobuchstaben: 
            if (chiffrat.charAt(i)>64) if (chiffrat.charAt(i)<91)
            temp.append(dechiffriereEinZeichen(chiffrat.charAt(i),schluessel.charAt(j)));
            j = (j+1) % schluessel.length();
        }
        dechiffrat=temp.toString();
    }
}